unit uMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, hyieutils, iexBitmaps, hyiedefs, iesettings, iexLayers, iexRulers, iexToolbars, ieopensavedlg,
  Vcl.Menus, ieview, imageenview, Vcl.Buttons, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    panBottom: TPanel;
    labSite: TLabel;
    progressBar: TProgressBar;
    panRight: TPanel;
    btnExecute: TSpeedButton;
    ienView: TImageEnView;
    MainMenu: TMainMenu;
    menuFile: TMenuItem;
    itemOpen: TMenuItem;
    itemSave: TMenuItem;
    menuSelections: TMenuItem;
    openDialog: TOpenImageEnDialog;
    edtFilter: TEdit;
    procedure btnExecuteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure itemOpenClick(Sender: TObject);
  private
    { Private declarations }
    srcImage, srcAlpha: TIEBitmap;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  pspiHost, pspiGlobals;


procedure TForm1.btnExecuteClick(Sender: TObject);
var
  filter: String;
  FP: Pointer;
  rc: Integer;
begin
  // execute filter
  srcImage := ienView.IEBitmap;
  if (srcImage.Width < 2 ) or ( srcImage.Height < 2 ) then
     exit;

  // some filters for testing
  //String filter := "D:/petra/pixopedia_distrib/Win32/Photoshop/Kyoto Color-120.8bf"; // ok
  //String filter := "D:\\petra\\pixopedia_distrib\\Win32\\Photoshop\\Zombie-140.8bf"; // ok
  //String filter := "D:/petra/pixopedia_distrib/Win32/Photoshop/grainnatural2.8bf";   // ok
  filter := edtFilter.text;

  if pspiPlugInLoad( PChar( filter )) <> 0 then
    MessageDlg( 'Error encountered loading plug-in', mtError, [ mbOK ], 0 )
  else
  begin
    FP := DisableTaskWindows( Handle );  // so that plugin window stay on top like modal
    try
      rc := pspiPlugInExecute( Handle );
    except
      rc := -1;
    end;
    EnableTaskWindows(FP);   // back to normal
    ienView.Update();
    if rc <> 0 then
      MessageDlg( 'Error encountered executing plug-in', mtError, [ mbOK ], 0 );
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  IEGlobalSettings().AutoFragmentBitmap := false;
  IEGlobalSettings().MsgLanguage := msEnglish;
  IEGlobalSettings().EnableTheming := true;
  //
  // SetExceptionMask(exAllArithmeticExceptions); // some filters need that
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ienView.Blank();

  // private TIEBitmaps
  srcImage := nil;
  srcAlpha := nil;

  pspiSetImageOrientation(PSPI_IMG_ORIENTATION_INVERT);
end;

procedure TForm1.itemOpenClick(Sender: TObject);
var
  atype: TImgType;
  w, h, iStride, aStride, res: Integer;
  iBuf, aBuf : pointer;
begin
  if (openDialog.Execute()) then
  begin
    if (ienView.IO.LoadFromFile(openDialog.FileName)) then
    begin
      w := 0;
      h := 0;
      iStride  := 0;
      aStride := 0;
      iBuf := 0;
      aBuf := 0;
      srcImage := ienView.IEBitmap;
      srcAlpha := nil;
      if (srcImage.PixelFormat = ie24RGB) then
        atype := PSPI_IMG_TYPE_BGR
      else
      if (srcImage.PixelFormat = ie8g) then
       atype := PSPI_IMG_TYPE_GRAY
      else
      begin
      // TODO: convert to ie24RGB...or something.
      end;
      w := srcImage.Width;
      h := srcImage.Height;
      iStride := srcImage.RowLen;
      iBuf := srcImage.ScanLine[h - 1];
      if (srcImage.HasAlphaChannel) then
      begin
        srcAlpha := srcImage.AlphaChannel;
        aStride := srcAlpha.RowLen;
        aBuf := srcAlpha.Scanline[h - 1];
      end;
      res := pspiSetImage(atype, w, h, iBuf, iStride, aBuf, aStride);
      if res <> 0 then
        MessageDlg( 'Error encountered setting image', mtError, [ mbOK ], 0 );

      (* TEST for adding scalines one by one
      // orientation set by pspiSetImageOrientation does not have effect when scanlines are added one by one
      // let's test scanline addition - works like a charm
      pspiStartImageSL(type, w, h, srcImage.HasAlphaChannel);
      for (int i := 0; i < h; i++)
        pspiAddImageSL(srcImage.ScanLine[i], srcImage.HasAlphaChannel ? srcAlpha.ScanLine[i] : 0);
      pspiFinishImageSL();
        *)
    end;
  end;
end;

end.
